Whamcloud - gitweb
LU-3963 ptlrpc: convert to linux list api
[fs/lustre-release.git] / lustre-iokit / obdfilter-survey / obdfilter-survey
index fd8407d..c65193e 100755 (executable)
@@ -1,5 +1,5 @@
 #!/bin/bash
-
+set -e
 ######################################################################
 # customize per survey
 
 # How to run test:
 # case 1 (local disk):
 #   $ nobjhi=2 thrhi=2 size=1024 case=disk sh obdfilter-survey
-#   instead of case=disk one can also run test as follows
-#   $ nobjhi=2 thrhi=2 size=1024 OSTS="lustre-OST0000 lustre-OST0001 ..." sh obdfilter-survey
+#   one can also run test with user defined targets as follows,
+#   $ nobjhi=2 thrhi=2 size=1024 targets="lustre-OST0000 lustre-OST0001 ..." sh obdfilter-survey
 # case 2 (network):
-#   $ nobjhi=2 thrhi=2 size=1024 server_nid="<name/nid_of_server>" case=network sh obdfilter-survey
-#   where, server_nid is name or ip address of system, which you want to 
+#   $ nobjhi=2 thrhi=2 size=1024 targets="<name/ip_of_server>" case=network sh obdfilter-survey
+#   where, targets is name or ip address of system, which you want to 
 #   set as server.
 # case 3 (network and disk):
 #   $ nobjhi=2 thrhi=2 size=1024 case=netdisk sh obdfilter-survey
-#   instead of case="netdisk" one can also run test as follows
-#   $ nobjhi=2 thrhi=2 size=1024 ECHO_CLIENTS="ECHO_<osc_name> ..." sh obdfilter-survey
+#   one can also run test with user defined targets as follows,
+#   $ nobjhi=2 thrhi=2 size=1024 targets="<osc_name> ..." sh obdfilter-survey
 #[ NOTE: It is advised to have automated login (passwordless entry) between server and 
 #  client systems on which this test runs.]
 
 # include library 
-source libecho
+source $(dirname $0)/iokit-libecho
 
 # The following variables can be set in the environment, or on the
 # command line
@@ -48,14 +48,20 @@ rslt=${rslt:-"$rslt_loc/obdfilter_survey_`date +%F@%R`_`uname -n`"}
 # Set this true to check file contents
 verify=${verify:-0}
 
+# test targets
+targets=${targets:-""}
+# test case
+case=${case:-"disk"}
+
 # total size (MBytes) per obd instance
 # large enough to avoid cache effects 
 # and to make test startup/shutdown overhead insignificant
 size=${size:-16384}
 
-# record size (KBytes)
+# record size (KBytes) ( 7168 max)
 rszlo=${rszlo:-1024}
 rszhi=${rszhi:-1024}
+rszmax=${rszmax:-4096}
 
 # number of objects per OST
 nobjlo=${nobjlo:-1}
@@ -66,10 +72,12 @@ nobjhi=${nobjhi:-16}
 thrlo=${thrlo:-1}
 thrhi=${thrhi:-16}
 
+export LC_ALL=POSIX
+
 # End of variables
 
 # create a set of objects, check there are 'n' contiguous ones and
-# return the first or 'ERROR'
+# echo out the first or 'ERROR'
 # parameter: 1. hostname
 #           2. device number
 #           3. number of object to be created (specified by user)
@@ -84,36 +92,37 @@ create_objects () {
     prev=0
     count=0
     error=0
-    while read line; do
-        echo "$line" | grep -q 'is object id'
-        if [ $?  -ne 0 ]; then
-            continue
-        fi
-        if [ $first -eq 0 ]; then
-            first=$(echo $line | awk '{print $6}')
-            first=$(printf "%d" $first)
-            prev=$first
-            count=1
-        else
-            obj=$(echo $line | awk '{print $6}') 
-            obj=$(printf "%d" $obj) 
-            diff=$((obj - (prev+1))) 
-            if [ $diff -ne 0 ]; then 
-                error=1 
-            fi 
-            prev=$obj 
-            count=$((count+1)) 
-        fi 
-    done < $rfile 
+
+    # Count number of objects (lines containing " is object id "), and
+    # ensure that the objects numbers are sequential.
+    #
+    exec 3< $rfile
+    while read -u3 line; do
+        case "$line" in
+        ( *' is object id '* )
+            set -- $line
+            if test $(( count += 1 )) -gt 1 ; then
+                (( $6 != prev + 1 )) && error=1
+            else
+                first=$(( $6 + 0 ))
+            fi
+            prev=$6
+            ;;
+        esac
+    done
+    exec 3<&-
+
     if [ $nobj -ne $count ]; then 
         echo "ERROR: $nobj != $count" >&2 
         cat $rfile >&2 
         echo "ERROR" 
     elif [ $error -ne 0 ]; then 
-        echo "ERROR: non contiguous objs found" >&2 
+        echo "ERROR: non contiguous objs found" >&2
+        echo ERROR
     else 
         echo $first 
     fi
+    return $error
 }
 
 # destroys all objects created in create_objects routine
@@ -132,6 +141,7 @@ get_stats () {
     gawk < $rfile \
        '/^Selected device [0-9]+$/ {n = 0; next}\
        /error/ {n = -1; exit}\
+       /^Total/ {next}\
        /^[0-9]+\/[0-9]+ Total: [0-9]+\.[0-9]+\/second$/ {n++; v=strtonum($3); \
                                                          if (n == 1 || v < min) min = v;\
                                                          if (n == 1 || v > max) max = v;\
@@ -166,6 +176,15 @@ testname2type () {
     esac
 }
 
+# for "echo_client + obdfilter" case, "prep + commit" mode should be used
+# for "echo_client + osc" case, "BRW" mode should be used
+testcase2mode() {
+    case $case in
+    disk) echo "p";;
+    *)    echo "g";;
+    esac
+}
+
 print_summary () {
     if [ "$1" = "-n" ]; then
         minusn=$1; shift
@@ -176,34 +195,50 @@ print_summary () {
     echo $minusn "$*"
 }
 
+version_code() {
+       # split arguments like "2.3.61" into "2", "3", "61"
+       eval set -- $(tr "[:punct:]" " " <<< $*)
+       echo -n "$((($1 << 16) | ($2 << 8) | $3))"
+}
+
+get_lustre_version() {
+       local host=${1:-${unique_hosts[0]}}
+       remote_shell $host $lctl get_param -n version |
+               awk '/^lustre:/ {print $2}'
+}
+
+# Check whether the record size (KBytes) exceeds the maximum bulk I/O RPC size
+# or not.
+check_record_size() {
+       [ $(version_code $(get_lustre_version)) -lt $(version_code 2.3.61) ] &&
+               rszmax=1024
+
+       if [ "$rszhi" -gt "$rszmax" ]; then
+               echo "Test disk case support maximum ${rszmax}KB IO data" \
+                    "(rszhi=$rszhi is too big), please use a smaller value."
+               return 1
+       fi
+       return 0
+}
+
 # Customisation variables
 #####################################################################
 # One can change variable values in this section as per requirements
 
-OSTS=${OSTS:-""}
-server_nid=${server_nid:-""}
-case=${case:-"disk"}
-if [ -n "$OSTS" ]; then
+if [ -n "$targets" ]; then
     declare -a ost_names
-    count=0
-    for name in $OSTS; do
-        ost_names[$count]=$name
-        count=$((count+1))
-    done
-fi
-ECHO_CLIENTS=${ECHO_CLIENTS:-""}
-if [ -n "$ECHO_CLIENTS" ]; then
-    # make sure we unset ost_names so that our client_names get noticed... 
-    unset ost_names
     declare -a client_names
     count=0
-    for name in $ECHO_CLIENTS; do
-        client_names[$count]=$name
+    for name in $targets; do
+        if [ $case == "disk" ]; then
+            ost_names[$count]=$name
+        else
+            client_names[$count]=$name
+        fi
         count=$((count+1))
     done
 fi
 
-
 # what tests to run (first must be write)
 tests_str=${tests_str:-""}
 if [ -n "$tests_str" ]; then
@@ -235,7 +270,7 @@ PAGE_SIZE=${PAGE_SIZE:-4}
 # (to avoid lctl ENOMEM problems)
 max_buffer_mem=$((1024 * 1024))
 snap=1
-
+clean_srv_OSS=0
 # Customisation variables ends here. 
 #####################################################################
 # leave the rest of this alone unless you know what you're doing...
@@ -268,9 +303,67 @@ else
     lctl=${lustre_root}/utils/lctl
 fi
 
+# split out hostnames from client/ost names
+ndevs=0
+for trgt in $targets; do
+    str=(`split_hostname $trgt`)
+    host_names[$ndevs]=${str[0]}
+    client_names[$ndevs]=${str[1]}
+    ndevs=$((ndevs+1))
+done
+if [ $case == "disk" ]; then
+    for ((i = 0; i < $ndevs; i++)); do
+        ost_names[$i]=${client_names[$i]}
+    done
+fi
+if [ $case == "netdisk" ]; then
+        if [ "$targets" ]; then
+            for ((i = 0; i < $ndevs; i++)); do
+                setup_osc_for_remote_ost ${host_names[$i]} \
+                                         ${client_names[$i]} $i
+                osc_name=${client_names[$i]}_osc
+                ec_using_osc $osc_name
+               cleanup_oscs="$cleanup_oscs $osc_name"
+            done
+        else
+            client_names_str=$($lctl dl | grep -v mdt | \
+                awk '{if ($2 == "UP" && $3 == "osc") {print $4} }')
+            count=0;
+            for name in $client_names_str; do
+                client_names[$count]=`echo $name | sed 's/-osc-.*$//'`
+                count=$((count+1))
+            done
+
+            host_names_str=$($lctl dl -t | grep -v mdt | \
+                awk '{if ($2 == "UP" && $3 == "osc") {print $7} }')
+            count=0;
+            for name in $host_names_str; do
+                host_names[$count]=`echo $name | sed 's/@.*$//'`
+                count=$((count+1))
+            done
+
+            for (( i = 0; i < $count; i++ )) do
+                setup_osc_for_remote_ost ${host_names[$i]} \
+                                         ${client_names[$i]} $i
+                osc_name=${client_names[$i]}_osc
+                ec_using_osc $osc_name
+               cleanup_oscs="$cleanup_oscs $osc_name"
+            done
+        fi
+
+        echo_clients=$($lctl dl | grep echo_client | awk "{if (\$2 == \"UP\" && \$3 == \"echo_client\") {print \$4} }")
+        cnt=0;
+        for name in $echo_clients; do
+            client_names[$cnt]=$name
+            host_names[$cnt]=localhost
+            cnt=$((cnt+1))
+        done
+        ndevs=${#client_names[@]}
+fi
 if [ $case == "network" ]; then
+    server_nid=$targets
     if [ -z "$server_nid" ]; then
-       echo "Specify the server NID"
+       echo "Specify hostname or ip-address of server"
        exit 1;
     fi
     # check for obdecho module on server
@@ -279,116 +372,54 @@ if [ $case == "network" ]; then
     fi
     # Now do the server setup
     setup_srv_obd $server_nid "echo_srv"
-    oss_on_srv=`dsh $server_nid root "lctl dl | grep OSS | awk '{ print $4 }'"`
-    if [ ! $oss_on_srv ]; then
+    oss_on_srv=`dsh $server_nid root "$lctl dl | grep OSS" | awk '{ print $4 }'`
+    if [ -z $oss_on_srv ]; then
         setup_OSS $server_nid
         clean_srv_OSS=1
     fi
-    if ! dsh $server_nid root "lctl dl | grep obdecho > /dev/null 2>&1"; then
+    if ! dsh $server_nid root "$lctl dl | grep obdecho > /dev/null 2>&1"; then
         echo "obdecho not setup on server"
         exit 1
     fi
-    if ! dsh $server_nid root "lctl dl | grep ost > /dev/null 2>&1"; then
+    if ! dsh $server_nid root "$lctl dl | grep ost > /dev/null 2>&1"; then
         echo "ost not setup on server"
         exit 1
     fi
     # Now start client setup
-    osc_names_str=$(lctl dl)
+    osc_names_str=$($lctl dl| grep osc | grep -v mdt | grep UP)
     if [ -n "$osc_names_str" ]; then
         echo "The existing setup must be cleaned";
         exit 0;
     fi
-    ec_using_srv_nid $server_nid "osc_testfs" "test_obdfs"
-    declare -a client_names
-    client_names[0]="ECHO_osc_testfs"
+    ec_using_srv_nid $server_nid "echotmp" "echotmp_UUID"
+    client_names[0]="echotmp_ecc"
 fi
-
-if [ -z "$ECHO_CLIENTS" ]; then
-    if [ $case == "netdisk" ]; then
-        declare -a osc_names
-        declare -a osc_uuids
-        osc_names_str=$(lctl dl |grep osc | awk "{if (\$2 == \"UP\" && \$3 == \"osc\") {print \$4} }")
-        count=0;
-        for name in $osc_names_str; do
-            osc_names[$count]=$name
-            count=$((count+1))
-        done
-        osc_uuid_str=$(lctl dl |grep osc | awk "{if (\$2 == \"UP\" && \$3 == \"osc\") {print \$5} }")
-        count=0;
-        for uuid in $osc_uuid_str; do
-            osc_uuids[$count]=$uuid
-            count=$((count+1))
-        done
-        for ((  i = 0 ;  i < $count;  i++  ))
-        do
-            ec_using_osc ${osc_names[$i]} ${osc_uuids[$i]}
-        done
-        ECHO_CLIENTS=$(lctl dl | grep echo_client | awk "{if (\$2 == \"UP\" && \$3 == \"echo_client\") {print \$4} }")
-        cnt=0;
-        for name in $ECHO_CLIENTS; do
-            client_names[$cnt]=$name
-            cnt=$((cnt+1))
-        done
-    fi
-fi
-
-if [ -z "$OSTS" ]; then
+if [ -z "$targets" ]; then
     if [ $case == "disk" ]; then
-       get_targets     
+       get_targets
+        ndevs=${#ost_names[@]} 
     fi 
 fi
-
-# split out hostnames from client/ost names
-ndevs=${#client_names[@]}
-if ((ndevs != 0)); then
-    if ((${#ost_names[@]} != 0)); then
-        echo "Please specify client_names or ost_names, but not both" 1>&2
-       exit 1
-    fi
-    for ((i = 0; i < ndevs; i++)); do
-       str=(`split_hostname ${client_names[$i]}`)
-       host_names[$i]=${str[0]}
-       client_names[$i]=${str[1]}
-    done
-else
-    ndevs=${#ost_names[@]}
-    if ((ndevs == 0)); then
-        echo "Please specify either client_names or ost_names" 1>&2
-       exit 1
-    fi
-    for ((i = 0; i < ndevs; i++)); do
-       str=(`split_hostname ${ost_names[$i]}`)
-       host_names[$i]=${str[0]}
-       ost_names[$i]=${str[1]}
-    done
-fi
-
 # get vmstat started
 # disable portals debug and get obdecho loaded on all relevant hosts
 unique_hosts=(`unique ${host_names[@]}`)
+load_obdechos
+
+if [ $case == "disk" ]; then
+       check_record_size || cleanup ${PIPESTATUS[0]}
+fi
+
 pidcount=0
 for host in ${unique_hosts[@]}; do
     host_vmstatf=${vmstatf}_${host}
     echo -n > $host_vmstatf
-    remote_shell $host "vmstat 5 >> $host_vmstatf" &
+    remote_shell $host "vmstat 5 >> $host_vmstatf" &> /dev/null &
     pid=$!
     vmstatpids[$pidcount]=$pid
     pidcount=$((pidcount+1))
-    do_unload_obdecho[$host]=0
-    if obdecho_loaded $host; then
-        continue
-    fi
-    load_obdecho $host
-    if obdecho_loaded $host; then
-        do_unload_obdecho[$host]=1
-        continue
-        fi
-    echo "Can't load obdecho on $host" 1>&2
-    exit 1
 done
-
 # get all the echo_client device numbers and names
-for ((i=0; i < ndevs; i++)); do
+for ((i=0; i < $ndevs; i++)); do
     host=${host_names[$i]}
     devno=(`get_ec_devno $host "${client_names[$i]}" "${ost_names[$i]}"`)
     if ((${#devno[@]} != 3)); then
@@ -398,6 +429,12 @@ for ((i=0; i < ndevs; i++)); do
     client_names[$i]=${devno[1]}
     do_teardown_ec[$i]=${devno[2]}
 done
+if (($ndevs <= 0 || ${#host_names[@]} <= 0)); then
+    echo "no devices or hosts specified"
+    cleanup 0 $clean_srv_OSS $cleanup_oscs
+fi
+# Buffers will be spread out among all hosts, so allow for that
+max_buffer_mem=$(( ${max_buffer_mem} * ${#unique_hosts[@]} ))
 print_summary "$(date) Obdfilter-survey for case=$case from $(hostname)"
 for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
     for ((nobj = $nobjlo; nobj <= $nobjhi; nobj*=2)); do 
@@ -426,7 +463,7 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
            actual_size=$((actual_rsz*count*thr))
             total_size=$((actual_size*ndevs))
            # show computed parameters
-           str=`printf 'ost %2d sz %8dK rsz %4d obj %4d thr %4d ' \
+           str=`printf 'ost %2d sz %8dK rsz %4dK obj %4d thr %4d ' \
                     $ndevs $total_size $actual_rsz $total_nobj $total_thr`
            echo "=======================> $str" >> $workf
            print_summary -n "$str"
@@ -436,7 +473,7 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
            fi
            # create the objects
            tmpf="${workf}_tmp"
-           for ((idx = 0; idx < ndevs; idx++)); do
+           for ((idx = 0; idx < $ndevs; idx++)); do
                host=${host_names[$idx]}
                devno=${devnos[$idx]}
                client_name="${host}:${client_names[$idx]}"
@@ -461,7 +498,7 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
                for host in ${unique_hosts[@]}; do
                    echo -n > ${cmdsf}_${host}
                done
-               for ((idx = 0; idx < ndevs; idx++)); do
+               for ((idx = 0; idx < $ndevs; idx++)); do
                    host=${host_names[$idx]}
                    devno=${devnos[$idx]}
                    tmpfi="${tmpf}_$idx"
@@ -470,7 +507,8 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
                    echo >> ${cmdsf}_${host} \
                        "$lctl > $tmpfi 2>&1 \\
                          --threads $thr -$snap $devno \\
-                        test_brw $count `testname2type $test` q $pages ${thr_per_obj}t${first_obj} &"
+                         test_brw $count `testname2type $test` q $pages \\
+                         ${thr_per_obj}t${first_obj} `testcase2mode`$pages &"
                 done
                 pidcount=0
                 for host in ${unique_hosts[@]}; do
@@ -497,20 +535,22 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
                 for host in ${unique_hosts[@]}; do
                     rm ${cmdsf}_${host}
                 done
+
                # compute bandwidth from total data / elapsed time
                str=`awk "BEGIN {printf \"%7.2f \",\
                         $total_size / (( $t1 - $t0 ) * 1024)}"`
                print_summary -n "$str"
                # collect/check individual OST stats
                echo -n > $tmpf
-               for ((idx = 0; idx < ndevs; idx++)); do
+               for ((idx = 0; idx < $ndevs; idx++)); do
                    client_name="${host_names[$idx]}:${client_names[$idx]}"
                    tmpfi="${tmpf}_$idx"
                    echo "=============> $test $client_name" >> $workf
                    host="${host_names[$idx]}"
-                   remote_shell $host cat $tmpfi >> $workf
-                   get_stats $tmpfi >> $tmpf
-                   rm $tmpfi
+                   remote_shell $host cat $tmpfi > ${tmpfi}_local
+                   cat ${tmpfi}_local >> $workf
+                   get_stats ${tmpfi}_local >> $tmpf
+                   rm -f $tmpfi ${tmpfi}_local
                done
                # compute/display global min/max stats
                echo "=============> $test global" >> $workf
@@ -532,7 +572,7 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
            done
            print_summary ""
            # destroy objects we created
-           for ((idx = 0; idx < ndevs; idx++)); do
+           for ((idx = 0; idx < $ndevs; idx++)); do
                host=${host_names[$idx]}
                devno=${devnos[$idx]}
                client_name="${host}:${client_names[$idx]}"
@@ -545,5 +585,5 @@ for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
        done
     done
 done
-cleanup 0 $clean_srv_OSS
+cleanup 0 $clean_srv_OSS $cleanup_oscs
 exit 0